<template>
    <div class="row justify-between full-width">
        <q-input class="col-9"
                 ref="input"
                 :rules="Rules"
                 :error="hasError"
                 :error-message="errorMessage"
                 type="text"
                 label-slot
                 :value="value"
                 @input="OnInput"
                 :input-style="`color: ${Color}`"
                 filled>
            <template v-slot:label>
                <LabelSlot :icon="icon" :label="label"
                           :tooltip="tooltip"/>
            </template>
        </q-input>
        <ColorPicker :value="value" @input="OnInput"/>
    </div>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import LabelSlot from "components/LabelSlot.vue";
import ColorPicker from "components/Core/ColorPicker.vue";
import tinycolor from 'tinycolor2'

@Component({
    components: {ColorPicker, LabelSlot}
})
export default class ColorInput extends Vue {
    @Prop() value!: string;
    @Prop({default: null}) prefix?: string;
    @Prop({default: null}) suffix?: string;
    @Prop({default: null}) rules?: any[];
    @Prop({default: null}) label?: string;
    @Prop({default: null}) icon?: string;
    @Prop({default: null}) tooltip?: string;
    @Prop({default: null}) hasError?: boolean;
    @Prop({default: null}) errorMessage?: string

    get Color() {
        const {r, g, b} = tinycolor(this.value).toRgb();

        return `rgba(${r},${g},${b}, 1)`;
    }

    get Rules() {
        const baseRule = [(v: string) => tinycolor(v).isValid() || 'Invalid Color']
        return [baseRule, ...(this.rules ?? [])]
    }

    OnInput(i: string) {
        this.$emit('input', i);
    }

    validate() {
        const qInput = this.$refs.input as any
        return qInput.validate();
    }
}
</script>
